clear();

m = 1.0;
r = 0.01;
l = 1.0;
J = 0.25*m*r*r + (1/12)*m*l*l;
pp = J+m*r*r;
g = 9.81;
qq = m*r*g;

P = 5*qq;
I = 0.0*P;
D = 0.2*P;

phisoll=0.0;

function f=modell(t,y)
       phi=y(1,1);
       omega=y(2,1);
       eInteg=y(3,1);

       e      =  phisoll - phi;       
       eDiff  = -omega; // == de/dt == dxsoll/dt - dx/dt == 0 - v

       M=P*e+I*eInteg+D*eDiff;

       f(1,1)=omega;
       f(2,1)=(qq/pp)*sin(phi)+M/pp;  //NICHT linearisiert!
//       f(2,1)=(qq/pp)*phi+M/pp;
       f(3,1)=e;
endfunction

t = linspace(0,9,900);
y0 = [0.2,0,0]';
t0 = 0;
y  = ode(y0,t0,t,modell);

plot(t,y(1,:)');

//Optimierung

function err=berechneFehler(x)
    P=x(1);
    I=x(2);
    D=x(3);

    t = linspace(0,9,900);
    y0 = [0.2,0,0]';
    t0 = 0;
    y  = ode(y0,t0,t,modell);

    err = sum(y(1,:).*y(1,:));
endfunction


P = 5*qq;
I = 0.0*P;
D = 0.2*P;

x0=[P;I;D];

[fopt, xopt, gopt] = optim(list(NDcost,berechneFehler), "b", x0.*0.001, x0.*1000.0, x0);

P=xopt(1);
I=xopt(2);
D=xopt(3);

t = linspace(0,9,900);
y0 = [0.2,0,0]';
t0 = 0;
y  = ode(y0,t0,t,modell);

plot(t,y(1,:)');



